program Project1;

uses
  windows,
  messages,
  graphics,
  sysutils,
  forms,
  directx;

{$R *.RES}

var
 Instance: HWnd;
 WindowClass: TWndClass;
 Handle: HWnd;
 msg: TMsg;
 FDrawObject : IDirectDraw;
 FBackCaps: TDDSCaps;
 FPrimarySurface : IDirectDrawSurface;
 FSecondarySurface : IDirectDrawSurface;
 FSurfaceDescription: TDDSurfaceDesc;


procedure DoExit;
begin
 FSecondarySurface:=nil;
 FPrimarySurface:=nil;
 FDrawObject:=nil;
 Halt;
end;

function windowproc (Hwn,msg,wpr,lpr: longint): longint; stdcall;
begin
 result:=defwindowproc(hwn,msg,wpr,lpr);
 if msg=wm_destroy then
  DoExit;
 if msg=wm_KeyDown then
  if wpr=VK_ESCAPE then
   DoExit;
end;

begin
 instance :=GetModuleHandle(nil);
 with WindowClass do
  begin
   style:=CS_HRedraw or CS_VRedraw;
   Lpfnwndproc:=@windowproc;
   Hinstance:=Instance;
   HbrBackground:= color_btnface;
   LpszClassName:='VR_DX';
   Hcursor:=LoadCursor(0,IDC_ARROW);
  end;
 RegisterClass (WindowClass);

 Handle:=CreateWindowEx (0,'VR_DX','',WS_POPUP, 5,5, GetSystemMetrics (SM_CXSCREEN), GetSystemMetrics (SM_CYSCREEN),0,0,instance, nil);
 UpdateWindow (Handle);

 DirectDrawCreate (nil,FDrawObject,nil);
 FDrawObject.SetCooperativeLevel (handle, DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN);

 FDrawObject.SetDisplayMode (800,600,16);
 with FSurfaceDescription do
  begin
   dwSize := sizeof(FSurfaceDescription);
   dwFlags := DDSD_CAPS or DDSD_BACKBUFFERCOUNT;
   ddsCaps.dwCaps :=DDSCAPS_PRIMARYSURFACE or DDSCAPS_FLIP or DDSCAPS_COMPLEX;
   DwBackBufferCount := 1;
  end;
 FDrawObject.CreateSurface (FSurfaceDescription,FPrimarySurface,nil);
 FBackCaps.dwCaps := DDSCAPS_BACKBUFFER;
 FPrimarySurface.GetAttachedSurface (FBackCaps,FSecondarySurface);
 FPrimarySurface.Flip(nil, DDFLIP_WAIT);

 while true do
  begin
   translatemessage(msg);
   dispatchmessage (msg);
   application.processmessages;
  end;
end.



